'use strict';

exports.__esModule = true;

exports.default = function (_ref) {
    var t = _ref.types;

    return {
        visitor: {
            MemberExpression: function MemberExpression(path) {
                return replaceNode(t, path);
            }
        }
    };
};

function isCharCode(path) {
    return path.node.property.name === 'charCodeAt' && path.parent.arguments[0].value === 0;
}

function replaceNode(t, path) {
    if (!isCharCode(path)) {
        return;
    }
    var object = path.node.object;

    if (object.type === 'StringLiteral') {
        return path.parentPath.replaceWith(t.numericLiteral(path.node.object.value.charCodeAt(0)));
    }
    if (object.type === 'TemplateLiteral' && !object.expressions.length) {
        return path.parentPath.replaceWith(t.numericLiteral(path.node.object.quasis[0].value.raw.charCodeAt(0)));
    }
}

module.exports = exports['default'];